//#define KATOD

#if defined (KATOD)
#	warning  COMMON KATOD
#else
#	warning  COMMON ANOD
#endif

//---------PORTB-PORTC---------
#ifdef KATOD
#	define COM_DIG_0	C,3,L
#	define COM_DIG_1	C,4,L
#	define COM_DIG_2	C,5,L

#	define SEG_0	B,1,H
#	define SEG_1	B,2,H
#	define SEG_2	B,3,H
#	define SEG_3	B,4,H
#	define SEG_4	B,5,H
#	define SEG_5	C,0,H
#	define SEG_6	C,1,H
#	define SEG_7	C,2,H
#else
#	define COM_DIG_0	C,3,H
#	define COM_DIG_1	C,4,H
#	define COM_DIG_2	C,5,H

#	define SEG_0	B,1,L
#	define SEG_1	B,2,L
#	define SEG_2	B,3,L
#	define SEG_3	B,4,L
#	define SEG_4	B,5,L
#	define SEG_5	C,0,L
#	define SEG_6	C,1,L
#	define SEG_7	C,2,L
#endif


//--------------------------------
#define PIN_BUTTON	PINB
#define PORT_BUTTON	PORTB
#define	DDR_BUTTON	DDRB

//#define KEY_PRESS(key)	((pin & (key))==0)
#define BTN_SET		_BV(1) 	
#define BTN_PLUS	_BV(3)  
#define BTN_MINUS	_BV(2)  
#define COM_BTN		_BV(4)  
#define BTNS		(BTN_SET|BTN_PLUS|BTN_MINUS|COM_BTN)
#define BTNS_PULLUP	(BTN_SET|BTN_PLUS|BTN_MINUS)

//-------- ------------------
#define	KEY_VOID	0	
#define	KEY_PLUS	BTN_PLUS
#define	KEY_MINUS	BTN_MINUS
#define	KEY_SET		BTN_SET


//----------  ----
#define PIN_INT		D,2,L

//------------------------
#define TRIAC		D,0,H




//--- ----------------
#define sA	_BV(0)
#define sB	_BV(1)
#define sC	_BV(2)
#define sD	_BV(3)
#define sE	_BV(4)
#define sF	_BV(5)
#define sG	_BV(6)
#define sH	_BV(7)
/*		 -A-
		F	B
		 -G-
		E	C
		 -D-	*/
const uint8_t font[]={
sA|sB|sC|sD|sE|sF,//0
sB|sC,//1
sA|sB|sG|sE|sD,//2
sA|sB|sG|sC|sD,//3
sF|sG|sB|sC,//4
sA|sF|sG|sC|sD,//5
sA|sF|sG|sC|sD|sE,//6
sA|sB|sC,//7
sA|sB|sC|sD|sE|sF|sG,//8
sA|sB|sC|sD|sG|sF,//9
sA|sD|sE|sF|sG,//E
sD|sE|sF|sG,//t
sB|sC|sD|sE|sG,//d
sA|sB|sC|sE|sF|sG,//A
sA|sB|sE|sF|sG,//P
sB|sC|sD|sF|sG,//
sA|sD|sE|sF,//C
sA|sE|sF|sG,//F
sC|sE|sG,//n
sF|sE|sD|sC|sB,//U
sC|sD|sE|sG,//o
sA|sE|sF,//f_G
sE|sF,//f_I
sA|sB|sC|sE|sF,//f_N
sC,//f_i
sD|sE|sG,//f_c
//sA|sB|sC|sD|sE|sF|sG,//8
};

#define f_E	10
#define f_t	11
#define f_d	12
#define f_A	13
#define f_P	14
#define f_y 15
#define f_C 16
#define f_F 17
#define f_n 18
#define f_U 19
#define f_o 20
#define f_G 21
#define f_I 22
#define f_N 23
#define f_i 24
#define f_c 25

//---Flag---
#define VIEWREG	_BV(0)
#define MIGANIE	_BV(1)

#define NUM_PRESET	4
struct {
	uint8_t RegimFi;
	uint8_t FiNumView;
	uint8_t IncPower;
	uint8_t Tim;
	uint8_t Preset[NUM_PRESET*2];// +2 -     OFF
	uint16_t crc;
	}Setting;
	
static uint8_t	antdr, count_press, povtor, Key, Inc, Blank, TimeState, regim;
static uint8_t	led_buffer[3], znmesto, Power, PowerTmp, eeprom_eer, LargeLimitReg,  ViewReg, Flag, Var, StepPreset=NUM_PRESET-1;
uint16_t TimeOff=0;

//#define TIME_POWER_OFF	(uint16_t)(300)// 0,1
//#define TIME_POWER_OFF_ALARM	(uint16_t)(TIME_POWER_OFF-100)
#define TIME_POWER_OFF	(uint16_t)(40*60*10)// 0,1
#define TIME_POWER_OFF_ALARM	(uint16_t)(TIME_POWER_OFF-10*60)


volatile uint8_t FlagIsr,TriacGate, ErrSinhro, EnTriac;
//static uint8_t tmp_uint8, *prm;
#if defined (__AVR_ATmega8__)
#	define Tim_Pause(tim)	( (tim/0.004)+1 ) 
#else
#	define Tim_Pause(tim)	( (tim/0.004)+1 )
#endif
const uint8_t pause_after_press[]={Tim_Pause(0.5), Tim_Pause(0.4), Tim_Pause(0.35), Tim_Pause(0.3), Tim_Pause(0.25), Tim_Pause(0.20), Tim_Pause(0.15), Tim_Pause(0.1)}; 

	
	
//-------------EEPROM-----------------
#define EEP_ADR	10
//------------------------------------
	
enum {ST_0=0, ST_INPUT_REG, ST_INPUT_TIP_REG, ST_TIP_REG, ST_SET_VIEW_FI, ST_SETTING_PRESET, ST_INC_POWER, ST_TIM, ST_PRESET,ST_END};

